import java.awt.Point;

import javax.swing.JOptionPane;

public class SLAnalyze {
	//depth 3ȉ̖̉͂߂l
	static final int RES_CHANGE=0;
	static final int RES_SAME=1;
	static final int RES_FINISH=2;
	static final int RES_ERROR=3;
	//static final int RES_NOLINE_NUMBER=4;	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
	static final int RES_LINELESS_NUMBER=4;	//[v1.7]Pƃ[vɁus̐v
	//citmpErrorLineŗpj
	static final int ANA_DIR_HOR=0;
	static final int ANA_DIR_VER=1;
	//}Xp̐̏o蔻̖߂l
	static final int COR_UNKNOWN=0;
	static final int COR_OPEN=1;
	static final int COR_CLOSE=2;
	//
	SLPanel puzzle;
	//
	int analyzeLevel;
	boolean messageFlag;		//w@̎s̓bZ[W\Ȃ
	boolean masterMessageFlag;	//𔻒E蔻ŊOύX
	//
	//͒ɔG[ꎞIɊi[iRES_ERRORԂƂݒj
	int tmpErrorX;
	int tmpErrorY;
	int tmpErrorLine;
	//͒̕ύXꎞIɊi[iRES_CHANGEԂƂݒjӁFċA钆ŕςĂ
	int tmpChangeX;
	int tmpChangeY;
	int tmpChangeLine;
	int tmpChangeExcept;
	//w@i̓x4`5jrŒ~
	boolean stopFlag;
	//[v1.4]depth 4̒ŏ[vւꂽ̂ێĂ
	boolean smallLoopFlag;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLAnalyze(SLPanel p){
		puzzle=p;
		//
		//analyzeLevel=0;
		messageFlag=true;
		masterMessageFlag=true;
		//stopFlag=false;
		smallLoopFlag=false;
	}
	//-------------------------------------------------------------
	//́i[m}X𖳎]LȂ疳tOtrueŁAnj
	//-------------------------------------------------------------
	public boolean analyze(SLData data,int level,boolean ignore){
		//
		analyzeLevel=level;
		stopFlag=false;		//͂̍ŏɃtO낵Ă
		//
		if(analyzeLevel<=1){
			return analyzeLevel1(data,ignore);
		}else if(analyzeLevel<=4){
			return analyzeLevel2to4(data,ignore);
		}else if(analyzeLevel==5){
			return analyzeLevel5(data,ignore);
		}else{
			return analyzeLevel6(data,ignore);
		}
	}
	//-------------------------------------------------------------*** level 0 ***
	//͑ÕG[`FbN
	//-------------------------------------------------------------*** depth - ***
	private boolean analyzeLevel0(SLData data,boolean ignore){
		//}Xm
		if(!ignore){	//m}XtO
			for(int h=0;h<data.height;h++){
				for(int w=0;w<data.width;w++){
					if(data.cellNum[w][h]==SLData.CELL_ANY){
						return showErrorMessage(LST.V[LST.ER_05]+"\n"+"i"+LST.V[LST.RIGHT]+"F"+(w+1)+","+LST.V[LST.DOWN]+"F"+(h+1)+"j");		//m̐
					}
				}
			}
		}
		//}XE_G[
		if(data.errors.size()!=0){
			SLError error=data.errors.get(0);
			switch(error.type){
			case SLError.ER_CELL_LESS:
				return showErrorMessage(LST.V[LST.ER_03]+"\ni"+LST.V[LST.RIGHT]+"F"+(error.posX+1)+","+LST.V[LST.DOWN]+"F"+(error.posY+1)+"j");	//̐菭Ȃ
			case SLError.ER_CELL_OVER:
				return showErrorMessage(LST.V[LST.ER_04]+"\ni"+LST.V[LST.RIGHT]+"F"+(error.posX+1)+","+LST.V[LST.DOWN]+"F"+(error.posY+1)+"j");	//̐葽
			case SLError.ER_POINT_STOP:
				return showErrorMessage(LST.V[LST.ER_09]+"\ni"+LST.V[LST.RIGHT]+"F"+(error.posX+1)+","+LST.V[LST.DOWN]+"F"+(error.posY+1)+"j");	//r؂Ă
			case SLError.ER_POINT_TREE:
				return showErrorMessage(LST.V[LST.ER_01]+"\ni"+LST.V[LST.RIGHT]+"F"+(error.posX+1)+","+LST.V[LST.DOWN]+"F"+(error.posY+1)+"j");	//܂͌Ă
			}
		}
		//[ṽG[
		if(SLContinueLine.loopSum>1){
			return showErrorMessage(LST.V[LST.ER_10]);		//[vłĂ
		}else if(SLContinueLine.loopSum==1){
			if(SLContinueLine.lineSum>1){
				return showErrorMessage(LST.V[LST.ER_11]);	//că[vĂ
			}else{
				/*
				if(data.checkNolineNumber()){	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
					return showErrorMessage("ĂȂ");
				}else{
					return showErrorMessage("ɊĂ");
				}*/
				if(data.checkLinelessNumber()){	//[v1.7]Pƃ[vɁus̐v
					return showErrorMessage(LST.V[LST.ER_08]);	//Ȃ
				}else{
					return showErrorMessage(LST.V[LST.ALREADY]+" "+LST.V[LST.COMPLETED]);
				}
			}
		}
		//
		return false;
	}
	//-------------------------------------------------------------*** level 1 ***
	//x1̉
	//-------------------------------------------------------------*** depth 1 ***
	public boolean analyzeLevel1(SLData data,boolean ignore){
		if(analyzeLevel0(data,ignore)){
			return true;
		}
		//
		for(int h=0;h<data.height;h++){
			for(int w=0;w<data.width;w++){
				switch(data.cellNum[w][h]){
				case SLData.CELL_NONE:
					break;
				case SLData.CELL_ANY:	//m}Xƃx0Ń`FbNꂸc
					break;
				case 0:
					if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
					if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
					if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
					if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
					break;
				case 3:
					//
					if(data.getCell(w-1, h-1)==0){	//
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
					}
					if(data.getCell(w, h-1)==0){	//
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
					}
					if(data.getCell(w+1, h-1)==0){	//E
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
					}
					if(data.getCell(w-1, h)==0){	//
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
					}
					switch(data.getCell(w+1, h)){	//E
					case 3:
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w+1,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						break;
					case 0:
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						break;
					}
					switch(data.getCell(w-1, h+1)){	//
					case 3:
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w-1,h+2,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w-1,h+2,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w-1,h+2,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w-1,h+2,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						break;
					case 0:
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						break;
					}
					switch(data.getCell(w, h+1)){	//
					case 3:
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h+1,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
						break;
					case 0:
						if(checkExitLevel1( setLineByPoint(data,w,h+1,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h+1,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+1,h,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
						break;
					}
					switch(data.getCell(w+1, h+1)){	//E
					case 3:
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_UP,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w,h,SLData.DIR_LEFT,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+2,h+2,SLData.DIR_UP,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+2,h+2,SLData.DIR_LEFT,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+2,h+2,SLData.DIR_DOWN,SLData.LINE_NONE) )){	return true;	}
						if(checkExitLevel1( setLineByPoint(data,w+2,h+2,SLData.DIR_RIGHT,SLData.LINE_NONE) )){	return true;	}
						break;
					case 0:
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_DOWN,SLData.LINE_EXIST) )){	return true;	}
						if(checkExitLevel1( setLineByCell(data,w,h,SLData.DIR_RIGHT,SLData.LINE_EXIST) )){	return true;	}
						break;
					}
					//
					break;
					/*
				case 1:
				case 2:
					break;
					*/
				}
			}
		}
		//
		return false;
	}
	//-------------------------------------------------------------*** level 1 ***
	//x1p̖߂lAIf
	//-------------------------------------------------------------*** depth 2 i߂l𔻒j***
	private boolean checkExitLevel1(int res){
		switch(res){
		case RES_CHANGE:
		case RES_SAME:
			return false;
		case RES_ERROR:
			return showErrorMessage();
		case RES_FINISH:
			return showFinishMessage();
		//case RES_NOLINE_NUMBER:		//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
			//return showErrorMessage("ĂȂ");
		case RES_LINELESS_NUMBER:		//[v1.7]Pƃ[vɁus̐v
			return showErrorMessage("Ȃ");
		default:	//dummy
			return true;
		}
	}
	//-------------------------------------------------------------*** level 2- ***
	//x2
	//-------------------------------------------------------------*** depth 1 iOĂяoj***
	public boolean analyzeLevel2to4(SLData data,boolean ignore){
		//͒~
		if(stopFlag){	return true;	}
		//
		if(analyzeLevel1(data,ignore)){
			return true;
		}
		//蓮ŕύXĂ鋰ꂪ̂Őݒ肵Ȃ
		if(analyzeLevel>=3){
			data.pointDir=new boolean[data.width+1][data.height+1][SLData.POINT_ALL];
		}
		//[vւ̂߂̃[v
		do{
			smallLoopFlag=false;	//ŏ̓tO~낵ĂiɗĂ΃[vƂȂj
			//[vh~
			if(analyzeLevel>=4){
				for(int l=1;l<data.contLines.length;l++){
					if(data.contLines[l]!=null){
						if(changeTerminalNear(data,l)){	return true;	}
					}
				}
			}
			//}X
			for(int w=0;w<data.width;w++){
				for(int h=0;h<data.height;h++){
					if(data.cellNum[w][h]>SLData.CELL_NONE && data.cellNum[w][h]<SLData.CELL_ALL){	//ẑߍH
						if( analyzeCell(data,w,h) ){ return true;	}
					}
				}
			}
			//_
			for(int w=0;w<data.width+1;w++){
				for(int h=0;h<data.height+1;h++){
					if( analyzePoint(data,w,h) ){ return true;	}
				}
			}
		}while(smallLoopFlag);		//ɏ[vփtOĂ΃[v
		//
		return false;
	}
	//analyzeLevel2to4()Ă΂A}X̉
	private boolean analyzeCell(SLData data,int w,int h){
		int exist=0;
		int none=0;
		//
		int cell=data.getCell(w, h);
		if(cell<1){
			return false;
		}else{
			for(int d=0;d<SLData.DIR_ALL;d++){
				switch(data.getLineByCell(w, h, d)){
				case SLData.LINE_NONE:
					none++;
					break;
				case SLData.LINE_EXIST:
					exist++;
					break;
				}
			}
		}
		//
		switch(cell){
		case 1:
			if(exist==0){
				if(none==3){
					if(changeBlankByCell(data,w,h,SLData.LINE_EXIST)){ return true; }
				}
			}else/* if(exist==1)*/{
				if(changeBlankByCell(data,w,h,SLData.LINE_NONE)){ return true; }
			}
			break;
		case 2:
			if(exist<2){
				if(none==2){
					if(changeBlankByCell(data,w,h,SLData.LINE_EXIST)){ return true; }
				}
			}else/* if(exist==2)*/{
				if(changeBlankByCell(data,w,h,SLData.LINE_NONE)){ return true; }
			}
			break;
		case 3:
			if(exist<3){
				if(none==1){
					if(changeBlankByCell(data,w,h,SLData.LINE_EXIST)){ return true; }
				}
			}else/* if(exist==3)*/{
				if(changeBlankByCell(data,w,h,SLData.LINE_NONE)){ return true; }
			}
			break;
		}
		//
		if(analyzeLevel>=3){
			if(analyzeCellCorner(data,w,h,cell)){	return true;	}
		}
		//
		return false;
	}
	private boolean changeBlankByCell(SLData data,int w,int h,int v){	//̃}X͂̋w̒lɂ
		for(int d=0;d<SLData.DIR_ALL;d++){
			if(data.getLineByCell(w, h, d)==SLData.LINE_BLANK){
				if(checkExitLevel2to4(data, setLineByCell(data,w,h,d,v) )){	return true;	}
			}
		}
		//
		return false;
	}
	//analyzeLevel2to4()Ă΂A_̉
	private boolean analyzePoint(SLData data,int w,int h){
		int[] lines=new int[SLData.DIR_ALL];
		int exist=0;
		int none=0;
		//
		for(int d=0;d<SLData.DIR_ALL;d++){
			lines[d]=data.getLineByPoint(w, h, d);
			switch(lines[d]){
			case SLData.LINE_NONE:
				none++;
				break;
			case SLData.LINE_EXIST:
				exist++;
				break;
			}
		}
		//
		switch(exist){
		case 0:
			if(none==3){
				if(changeBlankByPoint(data,w,h,SLData.LINE_NONE,lines)){ return true;	}
			}
			break;
		case 1:
			if(none==2){
				if(changeBlankByPoint(data,w,h,SLData.LINE_EXIST,lines)){ return true;	}
			}
			break;
		case 2:
			if(changeBlankByPoint(data,w,h,SLData.LINE_NONE,lines)){ return true;	}
			break;
		}
		//
		return false;
	}
	private boolean changeBlankByPoint(SLData data,int w,int h,int v,int[] lines){	//̓_͂̋w̒lɂ
		for(int d=0;d<SLData.DIR_ALL;d++){
			if(lines[d]==SLData.LINE_BLANK){
				if(checkExitLevel2to4(data, setLineByPoint(data,w,h,d,v) )){	return true;	}
			}
		}
		//
		return false;
	}
	//-------------------------------------------------------------*** level 3 ***
	//x3͂̕i
	//-------------------------------------------------------------*** depth 1 ***
	//analyzeCell()Ă΂A}Xւ̐̏o
	private boolean analyzeCellCorner(SLData data,int w,int h,int cell){
		//
		int pointX,pointY,pointD;				//ׂΏۂ̊p_Əo
		int forwardH,forwardV;					//ΓIȈړxNg
		int dirV,dirH,antiDirV,antiDirH;		//ΓIȕ
		int lineV,lineH,antiLineV,antiLineH;	//ΓIȈʒu̐
		//
		for(int d=0;d<4;d++){
			//p4ꂼɍ킹Đݒ
			switch(d){
			case 0:				//right-up
				pointX=w+1;pointY=h;pointD=SLData.POINT_RIGHT_UP;
				forwardH=1;forwardV=-1;
				dirV=SLData.DIR_UP;dirH=SLData.DIR_RIGHT;antiDirV=SLData.DIR_DOWN;antiDirH=SLData.DIR_LEFT;
				break;
			case 1:				//right-down
				pointX=w+1;pointY=h+1;pointD=SLData.POINT_RIGHT_DOWN;
				forwardH=1;forwardV=1;
				dirV=SLData.DIR_DOWN;dirH=SLData.DIR_RIGHT;antiDirV=SLData.DIR_UP;antiDirH=SLData.DIR_LEFT;
				break;
			case 2:				//left-down
				pointX=w;pointY=h+1;pointD=SLData.POINT_RIGHT_UP;
				forwardH=-1;forwardV=1;
				dirV=SLData.DIR_DOWN;dirH=SLData.DIR_LEFT;antiDirV=SLData.DIR_UP;antiDirH=SLData.DIR_RIGHT;
				break;
			case 3:				//left-up
				pointX=w;pointY=h;pointD=SLData.POINT_RIGHT_DOWN;
				forwardH=-1;forwardV=-1;
				dirV=SLData.DIR_UP;dirH=SLData.DIR_LEFT;antiDirV=SLData.DIR_DOWN;antiDirH=SLData.DIR_RIGHT;
				break;
			default:			//dummy
				pointX=w;pointY=h;pointD=SLData.POINT_RIGHT_DOWN;
				forwardH=-1;forwardV=-1;
				dirV=SLData.DIR_UP;dirH=SLData.DIR_LEFT;antiDirV=SLData.DIR_DOWN;antiDirH=SLData.DIR_RIGHT;
			}
			//
			lineV=data.getLineByPoint(pointX, pointY, dirV);
			lineH=data.getLineByPoint(pointX, pointY, dirH);
			antiLineV=data.getLineByPoint(pointX, pointY, antiDirV);
			antiLineH=data.getLineByPoint(pointX, pointY, antiDirH);
			//׎s
			switch(cell){
			case 1:
				switch(checkCornerIn1Cell(lineV,lineH,antiLineV,antiLineH,data.pointDir[pointX][pointY][pointD])){
				case COR_OPEN:
					if(setPointDirFlag(data,pointX,pointY,pointD,w,h,w+forwardH,h+forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX,pointY,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					//
					if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH,SLData.LINE_NONE)){	return true;	}
					if(fitLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH)){	return true;	}
					break;
				case COR_CLOSE:
					if(setPointDirFlag(data,pointX-forwardH,pointY-forwardV,pointD,w,h,w-forwardH,h-forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX-forwardH,pointY-forwardV,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					//
					if(changeLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
					if(fitLineByClosePointDir(data,pointX,pointY,dirV,dirH)){	return true;	}
					break;
				}
				break;
			case 2:
				switch(checkCornerIn2Cell(lineV,lineH,antiLineV,antiLineH,data.pointDir[pointX][pointY][pointD])){
				case COR_OPEN:		//Ίp󂭁Aׂ荇2͔Ȃ
					if(setPointDirFlag(data,pointX,pointY,pointD,w,h,w+forwardH,h+forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX,pointY,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					//
					if(setPointDirFlag(data,pointX-forwardH,pointY-forwardV,pointD,w,h,w-forwardH,h-forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX-forwardH,pointY-forwardV,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					break;
				case COR_CLOSE:		//ׂ荇2݂̂󂭁uΊp2ov
					if(setPointDirFlag(data,pointX-forwardH,pointY,reversePointDir(pointD),w,h,w-forwardH,h+forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX-forwardH,pointY,antiDirH,dirV,dirH,antiDirV)){	return true;	}
					//
					if(setPointDirFlag(data,pointX,pointY-forwardV,reversePointDir(pointD),w,h,w+forwardH,h-forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX,pointY-forwardV,dirH,antiDirV,antiDirH,dirV)){	return true;	}
					//
					if(checkLineExistByPointDir(data,pointX,pointY,dirV,dirH)){										//AO
						if(fitLineByClosePointDir(data,pointX,pointY,dirV,dirH)){	return true;	}
						if(changeLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
						if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH,SLData.LINE_EXIST)){	return true;	}
						if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
					}else if(checkLineExistByPointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH)){		//tAO
						if(changeLineByClosePointDir(data,pointX,pointY,dirV,dirH,SLData.LINE_NONE)){	return true;	}
						if(changeLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH,SLData.LINE_EXIST)){	return true;	}
						if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH,SLData.LINE_NONE)){	return true;	}
						if(fitLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH)){	return true;	}
					}else if(checkLineExistByPointDir(data,pointX,pointY,antiDirV,antiDirH)){						//tA
						if(changeLineByClosePointDir(data,pointX,pointY,dirV,dirH,SLData.LINE_NONE)){	return true;	}
						if(fitLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH)){	return true;	}
						if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH,SLData.LINE_NONE)){	return true;	}
						if(fitLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH)){	return true;	}
					}else if(checkLineExistByPointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH)){				//A
						if(fitLineByClosePointDir(data,pointX,pointY,dirV,dirH)){	return true;	}
						if(changeLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
						if(fitLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH)){	return true;	}
						if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
					}
					break;
				}
				break;
			case 3:
				switch(checkCornerIn3Cell(lineV,lineH,antiLineV,antiLineH,data.pointDir[pointX][pointY][pointD])){
				case COR_OPEN:
					if(setPointDirFlag(data,pointX,pointY,pointD,w,h,w+forwardH,h+forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX,pointY,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					//
					if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,dirV,dirH,SLData.LINE_EXIST)){	return true;	}
					if(changeLineByClosePointDir(data,pointX-forwardH,pointY-forwardV,antiDirV,antiDirH,SLData.LINE_NONE)){	return true;	}
					break;
				case COR_CLOSE:
					if(setPointDirFlag(data,pointX-forwardH,pointY-forwardV,pointD,w,h,w-forwardH,h-forwardV)){	return true;	}
					if(fitLineByOpenPointDir(data,pointX-forwardH,pointY-forwardV,dirH,dirV,antiDirH,antiDirV)){	return true;	}
					//
					if(changeLineByClosePointDir(data,pointX,pointY,dirV,dirH,SLData.LINE_NONE)){	return true;	}
					if(changeLineByClosePointDir(data,pointX,pointY,antiDirV,antiDirH,SLData.LINE_EXIST)){	return true;	}
					break;
				}
				break;
			}
		}
		//
		return false;
	}
	//}Xp̐̏otOݒ
	private boolean setPointDirFlag(SLData data,int pointX,int pointY,int pointD,int cellX1,int cellY1,int cellX2,int cellY2){
		if(!data.pointDir[pointX][pointY][pointD]){
			data.pointDir[pointX][pointY][pointD]=true;
			if( analyzeCell(data,cellX1,cellY1) ){ return true;	};
			if( analyzeCell(data,cellX2,cellY2) ){ return true;	};
		}
		//
		return false;
	}
	//}Xpɐ̏o肪ꍇɂāAĂɖ蕔킹iEOɁj
	private boolean fitLineByOpenPointDir(SLData data,int x,int y,int dirH,int dirV,int antiDirH,int antiDirV){
		//
		switch(data.getLineByPoint(x, y, dirH)){
		case SLData.LINE_EXIST:
			if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirV,SLData.LINE_NONE) )){	return true; }
			break;
		case SLData.LINE_NONE:
			if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirV,SLData.LINE_EXIST) )){	return true; }
			break;
		case SLData.LINE_BLANK:
			switch(data.getLineByPoint(x, y, dirV)){
			case SLData.LINE_EXIST:
				if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirH,SLData.LINE_NONE) )){	return true; }
				break;
			case SLData.LINE_NONE:
				if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirH,SLData.LINE_EXIST) )){	return true; }
				break;
			}
			break;
		}
		//
		return false;
	}
	//}Xpɐ̏o肪ȂꍇɂāAĂɖ蕔킹iÔǂ炩̂݁j
	private boolean fitLineByClosePointDir(SLData data,int x,int y,int dirV,int dirH){
		//
		int lineV=data.getLineByPoint(x, y, dirV);
		int lineH=data.getLineByPoint(x, y, dirH);
		if(lineV!=SLData.LINE_BLANK){
			if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirH,lineV) )){	return true; }
		}else if(lineH!=SLData.LINE_BLANK){
			if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirV,lineH) )){	return true; }
		}
		//
		return false;
	}
	//}Xpɐ̏o肪ȂꍇɂāAw̒lɂiÔǂ炩̂݁j
	private boolean changeLineByClosePointDir(SLData data,int x,int y,int dirV,int dirH,int line){
		//
		if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirV,line) )){	return true; }
		if(checkExitLevel2to4(data, setLineByPoint(data,x, y, dirH,line) )){	return true; }
		//
		return false;
	}
	//2Cell̑Ίp2o̍ۂɁAgƂȂ2̂ǂ炩Ă邩ǂ
	private boolean checkLineExistByPointDir(SLData data,int x,int y,int dirV,int dirH){
		if(data.getLineByPoint(x, y, dirV)==SLData.LINE_EXIST){
			return true;
		}
		if(data.getLineByPoint(x, y, dirH)==SLData.LINE_EXIST){
			return true;
		}
		//
		return false;
	}
	//̏ot]
	private int reversePointDir(int dir){
		if(dir==SLData.POINT_RIGHT_UP){
			return SLData.POINT_RIGHT_DOWN;
		}else/* if(dir==SLData.POINT_RIGHT_DOWN)*/{
			return SLData.POINT_RIGHT_UP;
		}
	}
	//e}X̊p̓_ɂȀo𔻒
	//1cell
	private int checkCornerIn1Cell(int lineV,int lineH,int antiLineV,int antiLineH,boolean openFlag){
		//
		if(openFlag){	return COR_OPEN;	}
		if(lineV==SLData.LINE_EXIST){
			if(lineH==SLData.LINE_EXIST){
				return COR_CLOSE;
			}else if(lineH==SLData.LINE_NONE){
				return COR_OPEN;
			}
		}else if(lineV==SLData.LINE_NONE){
			if(lineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}else if(lineH==SLData.LINE_NONE){
				return COR_CLOSE;
			}
		}
		if(antiLineV==SLData.LINE_EXIST){
			return COR_OPEN;
		}else if(antiLineV==SLData.LINE_NONE){
			if(antiLineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}else if(antiLineH==SLData.LINE_NONE){
				return COR_CLOSE;
			}
		}
		//
		return COR_UNKNOWN;
	}
	//2cell
	private int checkCornerIn2Cell(int lineV,int lineH,int antiLineV,int antiLineH,boolean openFlag){
		//
		if(openFlag){	return COR_OPEN;	}
		if(lineV==SLData.LINE_EXIST){
			if(lineH==SLData.LINE_EXIST){
				return COR_CLOSE;
			}else if(lineH==SLData.LINE_NONE){
				return COR_OPEN;
			}
		}else if(lineV==SLData.LINE_NONE){
			if(lineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}else if(lineH==SLData.LINE_NONE){
				return COR_CLOSE;
			}
		}
		if(antiLineV==SLData.LINE_EXIST){
			if(antiLineH==SLData.LINE_EXIST){
				return COR_CLOSE;
			}else if(antiLineH==SLData.LINE_NONE){
				return COR_OPEN;
			}
		}else if(antiLineV==SLData.LINE_NONE){
			if(antiLineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}else if(antiLineH==SLData.LINE_NONE){
				return COR_CLOSE;
			}
		}
		//
		return COR_UNKNOWN;
	}
	//3Cell
	private int checkCornerIn3Cell(int lineV,int lineH,int antiLineV,int antiLineH,boolean openFlag){
		//
		if(openFlag){	return COR_OPEN;	}
		if(lineV==SLData.LINE_EXIST){
			return COR_OPEN;
		}else if(lineV==SLData.LINE_NONE){
			if(lineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}else if(lineH==SLData.LINE_NONE){
				return COR_CLOSE;
			}
		}else{
			if(lineH==SLData.LINE_EXIST){
				return COR_OPEN;
			}
		}
		if(antiLineV==SLData.LINE_EXIST && antiLineH==SLData.LINE_EXIST){	return COR_CLOSE;	}
		//
		return COR_UNKNOWN;
	}
	//-------------------------------------------------------------*** level 4 ***
	//x4͂̕i
	//-------------------------------------------------------------*** depth 1 ***
	//A̒f[ׂ荇ĂΊԂ~ɂidepth 1ĂяoAdepth 4ł͌ĂяotO𗧂Ă悤ɂj
	private boolean changeTerminalNear(SLData data,int changedLineNum){
		//if(changedLineNum!=0){	//depth 4ŌĂ΂鎞̂
			int dir=data.contLines[changedLineNum].checkTerminalNear(data);
			if(dir!=SLData.DIR_ALL){
				tmpChangeExcept=SLData.DIR_ALL;	//Oɂe邪dȂ
				Point point=data.contLines[changedLineNum].terminalPoints.get(0);
				return checkExitLevel2to4(data,setLineByPoint(data,point.x,point.y,dir,SLData.LINE_NONE));
			}
		//}
		//
		return false;
	}
	//-------------------------------------------------------------*** level 2-4 ***
	//x2`4̖͂߂lAIfiċAĂяoj
	//-------------------------------------------------------------*** depth 2 ***
	private boolean checkExitLevel2to4(SLData data,int res){
		switch(res){
		case RES_CHANGE:
			//lڂĂiċA钆ŕς̂Łj
			int changeX=tmpChangeX;
			int changeY=tmpChangeY;
			//
			if(tmpChangeLine==ANA_DIR_HOR){
				switch(tmpChangeExcept){
				case SLData.DIR_UP:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//LEFT
					if(analyzePoint(data,changeX+1,changeY)){	return true;	}	//RIGHT
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//DOWN
					break;
				case SLData.DIR_DOWN:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//LEFT
					if(analyzePoint(data,changeX+1,changeY)){	return true;	}	//RIGHT
					if(analyzeCell(data,changeX,changeY-1)){	return true;	}	//UP
					break;
				case SLData.DIR_RIGHT:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//LEFT
					if(analyzeCell(data,changeX,changeY-1)){	return true;	}	//UP
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//DOWN
					break;
				case SLData.DIR_LEFT:
					if(analyzePoint(data,changeX+1,changeY)){	return true;	}	//RIGHT
					if(analyzeCell(data,changeX,changeY-1)){	return true;	}	//UP
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//DOWN
					break;
				case SLData.DIR_ALL:	//analyze level 4
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//LEFT
					if(analyzePoint(data,changeX+1,changeY)){	return true;	}	//RIGHT
					if(analyzeCell(data,changeX,changeY-1)){	return true;	}	//UP
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//DOWN
					break;
				}
				//
				if(analyzeLevel>=3){
					if(analyzeCell(data,changeX+1,changeY-1)){	return true;	}	//RIGHT-UP
					if(analyzeCell(data,changeX+1,changeY)){	return true;	}	//RIGHT-DOWN
					if(analyzeCell(data,changeX-1,changeY-1)){	return true;	}	//LEFT-UP
					if(analyzeCell(data,changeX-1,changeY)){	return true;	}	//LEFT-DOWN
				}
			}else if(tmpChangeLine==ANA_DIR_VER){
				switch(tmpChangeExcept){
				case SLData.DIR_UP:
					if(analyzePoint(data,changeX,changeY+1)){	return true;	}	//DOWN
					if(analyzeCell(data,changeX-1,changeY)){	return true;	}	//LEFT
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//RIGHT
					break;
				case SLData.DIR_DOWN:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//UP
					if(analyzeCell(data,changeX-1,changeY)){	return true;	}	//LEFT
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//RIGHT
					break;
				case SLData.DIR_RIGHT:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//UP
					if(analyzePoint(data,changeX,changeY+1)){	return true;	}	//DOWN
					if(analyzeCell(data,changeX-1,changeY)){	return true;	}	//LEFT
					break;
				case SLData.DIR_LEFT:
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//UP
					if(analyzePoint(data,changeX,changeY+1)){	return true;	}	//DOWN
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//RIGHT
					break;
				case SLData.DIR_ALL:	//analyze level 4
					if(analyzePoint(data,changeX,changeY)){	return true;	}	//UP
					if(analyzePoint(data,changeX,changeY+1)){	return true;	}	//DOWN
					if(analyzeCell(data,changeX-1,changeY)){	return true;	}	//LEFT
					if(analyzeCell(data,changeX,changeY)){	return true;	}	//RIGHT
					break;
				}
				//
				if(analyzeLevel>=3){
					if(analyzeCell(data,changeX-1,changeY-1)){	return true;	}	//LEFT-UP
					if(analyzeCell(data,changeX,changeY-1)){	return true;	}	//RIGHT-UP
					if(analyzeCell(data,changeX-1,changeY+1)){	return true;	}	//LEFT-DOWN
					if(analyzeCell(data,changeX,changeY+1)){	return true;	}	//RIGHT-DOWN
				}
			}
			return false;
		case RES_SAME:
			return false;
		case RES_ERROR:
			//[v1.8]Ֆʂł͕s̃G[i܂G[ł͂ȂƃG[ɂȂiKő邱ƂjpɃ`FbN
			data.unvisibleErrorFlag=true;
			//
			return showErrorMessage();
		case RES_FINISH:
			return showFinishMessage();
		//case RES_NOLINE_NUMBER:		//[v1.4]Pƃ[vɁu͂ꐔv
			//return showErrorMessage("ĂȂ");
		case RES_LINELESS_NUMBER:		//[v1.7]Pƃ[vɁu͂ꐔv
			//[v1.8]Ֆʂł͕s̃G[i܂G[ł͂ȂƃG[ɂȂiKő邱ƂjpɃ`FbN
			data.unvisibleErrorFlag=true;
			//
			return showErrorMessage(LST.V[LST.ER_08]);	//Ȃ
		default:	//dummy
			return true;
		}
	}
	//-------------------------------------------------------------*** level 5 ***
	//x5̉
	//-------------------------------------------------------------*** depth 1 ***
	private boolean analyzeLevel5(SLData data,boolean ignore){
		if(analyzeLevel2to4(data,ignore)){
			return true;
		}
		//ύXtO
		boolean mistakeFlag=false;
		//w@
		messageFlag=false;							//OPFw@̊Ԃ̓bZ[W\Ȃ
		int tmpLineSum=SLContinueLine.lineSum;		//OQFNXϐޔĂ
		int tmpLoopSum=SLContinueLine.loopSum;
		//
		if(tmpLineSum>0){	//܂ʂ̖ŁAĂĒf[
			loopA:	for(int c=1;c<data.contLines.length;c++){
				if(data.contLines[c]==null){	continue;	}
				for(int t=0;t<2;t++){
					//͒~
					if(stopFlag){	break loopA;	}
					//
					Point p=data.contLines[c].terminalPoints.get(t);
					for(int d=0;d<SLData.DIR_ALL;d++){
						if(data.getLineByPoint(p.x, p.y, d)==SLData.LINE_BLANK){
							//i̎ɃNXϐ͏Ăj
							SLData tmpData=data.clone();
							//󔒂ɐAG[ɂȂ΁A~ɂiύXǐՉ͂́Ał͂Ȃj
							tmpData.setLineByPoint(p.x, p.y, d, SLData.LINE_EXIST);
							if(analyzeLevel2to4(tmpData,ignore) && checkErrorOnTmpData(tmpData)){
								mistakeFlag=true;
								data.setLineByPoint(p.x, p.y, d, SLData.LINE_NONE);
							}
						}
					}
				}
			}
		}else{				//[v1.5]ȖŉȂA܂ŐĂȂ
			SLData tmpData;	//SĂ̐ɂāuj]邩炱́~vƂw@
			//
			loopB:	for(int x=0;x<data.width;x++){	//[̉ƉE[̏cȊȎSĂ̐
				for(int y=0;y<data.height;y++){
					//͒~
					if(stopFlag){	break loopB;	}
					//A󔒂ɐAG[ɂȂ΁~ɂ
					tmpData=data.clone();
					tmpData.setLineByPoint(x,y,SLData.DIR_RIGHT,SLData.LINE_EXIST);
					if(analyzeLevel2to4(tmpData,ignore) && checkErrorOnTmpData(tmpData)){
						mistakeFlag=true;
						data.setLineByPoint(x, y, SLData.DIR_RIGHT, SLData.LINE_NONE);
					}
					//
					tmpData=data.clone();
					tmpData.setLineByPoint(x,y,SLData.DIR_DOWN,SLData.LINE_EXIST);
					if(analyzeLevel2to4(tmpData,ignore) && checkErrorOnTmpData(tmpData)){
						mistakeFlag=true;
						data.setLineByPoint(x, y, SLData.DIR_DOWN, SLData.LINE_NONE);
					}
				}
			}
			//
			for(int x=0;x<data.width;x++){			//[̉
				//͒~
				if(stopFlag){	break;	}
				//A󔒂ɐAG[ɂȂ΁~ɂ
				tmpData=data.clone();
				tmpData.setLineByPoint(x,data.height,SLData.DIR_RIGHT,SLData.LINE_EXIST);
				if(analyzeLevel2to4(tmpData,ignore) && checkErrorOnTmpData(tmpData)){
					mistakeFlag=true;
					data.setLineByPoint(x, data.height, SLData.DIR_RIGHT, SLData.LINE_NONE);
				}
			}
			//
			for(int y=0;y<data.height;y++){			//E[̏c
				//͒~
				if(stopFlag){	break;	}
				//A󔒂ɐAG[ɂȂ΁~ɂ
				tmpData=data.clone();
				tmpData.setLineByPoint(data.width,y,SLData.DIR_DOWN,SLData.LINE_EXIST);
				if(analyzeLevel2to4(tmpData,ignore) && checkErrorOnTmpData(tmpData)){
					mistakeFlag=true;
					data.setLineByPoint(data.width, y, SLData.DIR_DOWN, SLData.LINE_NONE);
				}
			}
		}
		//
		SLContinueLine.lineSum=tmpLineSum;	//㏈PFNXϐɖ߂
		SLContinueLine.loopSum=tmpLoopSum;
		messageFlag=true;					//㏈QFbZ[W\悤ɖ߂
		//ύXΓ͂JԂiċAĂяoj
		if(mistakeFlag){
			if(analyzeLevel5(data,ignore)){	return true;	}
		}
		//
		return false;
	}
	//̃G[oix5`6Ŏgj
	private boolean checkErrorOnTmpData(SLData data){
		//}XE_G[
		if(data.errors.size()!=0){	return true;	}
		//[ṽG[
		if(SLContinueLine.loopSum>1){
			return true;
		}else if(SLContinueLine.loopSum==1){
			if(SLContinueLine.lineSum>1){
				return true;
				/*
			}else{
				if(data.checkNolineNumber()){	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
					return true;
				}*/
			}else{
				if(data.checkLinelessNumber()){	//[v1.7]Pƃ[vɁus̐v
					return true;
				}
			}
		}
		//[v1.8]Ֆʂł͕s̃G[i܂G[ł͂ȂƃG[ɂȂiKő邱Ƃj
		if(data.unvisibleErrorFlag){
			return true;
		}
		//
		return false;
	}
	//-------------------------------------------------------------*** level 6 ***
	//x6̉
	//-------------------------------------------------------------*** depth 1 ***
	private boolean analyzeLevel6(SLData data,boolean ignore){
		if(analyzeLevel5(data,ignore)){
			return true;
		}
		//
		//ύXtO
		boolean mistakeFlag=false;
		//w@
		messageFlag=false;							//OPFw@̊Ԃ̓bZ[W\Ȃ
		int tmpLineSum=SLContinueLine.lineSum;		//OQFNXϐޔĂ
		int tmpLoopSum=SLContinueLine.loopSum;
loopA:	for(int c=1;c<data.contLines.length;c++){
			if(data.contLines[c]==null){	continue;	}
			for(int t=0;t<2;t++){
				//͒~
				if(stopFlag){	break loopA;	}
				//
				Point p=data.contLines[c].terminalPoints.get(t);
				for(int d=0;d<SLData.DIR_ALL;d++){
					if(data.getLineByPoint(p.x, p.y, d)==SLData.LINE_BLANK){
						//i̎ɃNXϐ͏Ăj
						SLData tmpData=data.clone();
						//󔒂ɐAG[ɂȂ΁A~ɂiύXǐՉ͂́Ał͂Ȃj
						tmpData.setLineByPoint(p.x, p.y, d, SLData.LINE_EXIST);
						if(analyzeLevel2to4(tmpData,ignore)){	//bZ[W\̓sŃx5͎͂gÂ炢
							if(checkErrorOnTmpData(tmpData)){				//G[
								mistakeFlag=true;
								data.setLineByPoint(p.x, p.y, d, SLData.LINE_NONE);
							}
						}else{												//fłȂΎ̓_֐iݒׂ
							if(checkErrorOnPoint(tmpData,searchNextPoint(tmpData,p,d),ignore)){
								mistakeFlag=true;
								data.setLineByPoint(p.x, p.y, d, SLData.LINE_NONE);
							}
						}
					}
				}
			}
		}
		SLContinueLine.lineSum=tmpLineSum;	//㏈PFNXϐɖ߂
		SLContinueLine.loopSum=tmpLoopSum;
		messageFlag=true;					//㏈QFbZ[W\悤ɖ߂
		//ύXΓ͂JԂiċAĂяoj
		if(mistakeFlag){
			if(analyzeLevel6(data,ignore)){	return true;	}
		}
		//܂ĂȂiʉj
		return false;
	}
	//̒f[̃[gSăG[ɂȂs~܂邩ǂ
	private boolean checkErrorOnPoint(SLData data,Point p,boolean ignore){
		//ċÂŉ𓚒~
		if(p==null){
			JOptionPane.showMessageDialog(puzzle,"StackOverflowError\n"+LST.V[LST.ER_00],LST.V[LST.ERROR],JOptionPane.ERROR_MESSAGE);	//̌Eɂ͂𒆎~
			stopFlag=true;
			return false;
		}
		//悪肤tO
		boolean ableFlag=false;
		//Ăяô͔w@simessageFlagfalsê܂܁j
		//ɔw@
		int tmpLineSum=SLContinueLine.lineSum;		//OFNXϐޔĂ
		int tmpLoopSum=SLContinueLine.loopSum;
		for(int d=0;d<SLData.DIR_ALL;d++){
			if(data.getLineByPoint(p.x, p.y, d)==SLData.LINE_BLANK){
				//i̎ɃNXϐ͏Ăj
				SLData tmpData=data.clone();
				//󔒂ɐG[ɂȂȂ΁A[g肤̂Ŗ߂
				tmpData.setLineByPoint(p.x, p.y, d, SLData.LINE_EXIST);
				if(analyzeLevel2to4(tmpData,ignore)){	//bZ[W\̓sŃx5͎͂gÂ炢
					if(!checkErrorOnTmpData(tmpData)){		//Ă
						ableFlag=true;
						break;
					}
				}else{										//fłȂΎ̓_֐iݒׂiċAĂяoj
					if(!checkErrorOnPoint(tmpData,searchNextPoint(tmpData,p,d),ignore)){
						ableFlag=true;
						break;
					}
				}
			}
		}
		SLContinueLine.lineSum=tmpLineSum;	//㏈FNXϐɖ߂
		SLContinueLine.loopSum=tmpLoopSum;
		if(ableFlag){
			return false;
		}else{
			//SăG[ɂȂ
			return true;
		}
	}
	//̓_炻̕։тsf[
	private Point searchNextPoint(SLData data,Point p,int toDir){
		int dx=0;
		int dy=0;
		int fromDir;
		switch(toDir){
		case SLData.DIR_UP:
			dy--;
			fromDir=SLData.DIR_DOWN;
			break;
		case SLData.DIR_DOWN:
			dy++;
			fromDir=SLData.DIR_UP;
			break;
		case SLData.DIR_LEFT:
			dx--;
			fromDir=SLData.DIR_RIGHT;
			break;
		case SLData.DIR_RIGHT:
			dx++;
			fromDir=SLData.DIR_LEFT;
			break;
		default:	//dummy
			fromDir=SLData.DIR_ALL;
		}
		try{
			//܂ĂΎ̓_ցiċAĂяoj
			for(int d=0;d<SLData.DIR_ALL;d++){
				if(d==fromDir){	continue;	}
				if(data.getLineByPoint(p.x+dx, p.y+dy, d)==SLData.LINE_EXIST){
					//͌ʂpifalsejȂ̂mFɌĂяoĂ
					//烋[v͂łĂ炸A[ṽ`FbN͕sv̂͂
					return searchNextPoint(data,new Point(p.x+dx, p.y+dy),d);
				}
			}
			//̓_f[
			return new Point(p.x+dx, p.y+dy);
		}catch(StackOverflowError e){
			//ċAꍇ͉𓚒~ɂiŏNoClassDefFoundError̂ŏłj
			return null;
		}
	}
	//-------------------------------------------------------------*** level 1- ***
	//}XE_ăANZXiz͈̔͂lAL蓾Ȃ}XE_ł͔zOɂȂj
	//-------------------------------------------------------------*** depth 3 ***
	//
	private int setLineByPoint(SLData data,int x,int y,int d,int v){
		switch(d){
		case SLData.DIR_UP:
			if(y>0){
				tmpChangeExcept=SLData.DIR_DOWN;
				return changeVerLine(data,x,y-1,data.lineVer[x][y-1],v);
			}else{
				if(v==SLData.LINE_EXIST){
					tmpErrorX=x;tmpErrorY=y-1;tmpErrorLine=ANA_DIR_VER;
					return RES_ERROR;
				}else{
					return RES_SAME;
				}
			}
		case SLData.DIR_DOWN:
			if(y<data.height){
				tmpChangeExcept=SLData.DIR_UP;
				return changeVerLine(data,x,y,data.lineVer[x][y],v);
			}else{
				if(v==SLData.LINE_EXIST){
					tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_VER;
					return RES_ERROR;
				}else{
					return RES_SAME;
				}
			}
		case SLData.DIR_RIGHT:
			if(x<data.width){
				tmpChangeExcept=SLData.DIR_LEFT;
				return changeHorLine(data,x,y,data.lineHor[x][y],v);
			}else{
				if(v==SLData.LINE_EXIST){
					tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_HOR;
					return RES_ERROR;
				}else{
					return RES_SAME;
				}
			}
		case SLData.DIR_LEFT:
			if(x>0){
				tmpChangeExcept=SLData.DIR_RIGHT;
				return changeHorLine(data,x-1,y,data.lineHor[x-1][y],v);
			}else{
				if(v==SLData.LINE_EXIST){
					tmpErrorX=x-1;tmpErrorY=y;tmpErrorLine=ANA_DIR_HOR;
					return RES_ERROR;
				}else{
					return RES_SAME;
				}
			}
		default:	//dummy
			return RES_SAME;
		}
	}
	//
	private int setLineByCell(SLData data,int x,int y,int d,int v){
		switch(d){
		case SLData.DIR_UP:
			tmpChangeExcept=SLData.DIR_DOWN;
			return changeHorLine(data,x,y,data.lineHor[x][y],v);
		case SLData.DIR_DOWN:
			tmpChangeExcept=SLData.DIR_UP;
			return changeHorLine(data,x,y+1,data.lineHor[x][y+1],v);
		case SLData.DIR_RIGHT:
			tmpChangeExcept=SLData.DIR_LEFT;
			return changeVerLine(data,x+1,y,data.lineVer[x+1][y],v);
		case SLData.DIR_LEFT:
			tmpChangeExcept=SLData.DIR_RIGHT;
			return changeVerLine(data,x,y,data.lineVer[x][y],v);
		default:	//dummy
			return RES_SAME;
		}
	}
	//-------------------------------------------------------------*** level 1- ***
	//ځAzɃANZX
	//-------------------------------------------------------------*** depth 4 ***
	private int changeHorLine(SLData data,int x,int y,int before,int after){
		if(before==SLData.LINE_BLANK){
			data.lineHor[x][y]=after;
			if(masterMessageFlag){	puzzle.changeFlag=true;	}	//E蔻̎͌f[^̕ύX͂Ȃ
			if(analyzeLevel>=4){				//[vւ̃`FbN܂
				int changedLineNum=data.setNewHorLineNum(x,y,before,after);
				if(changedLineNum!=0){			//ύXƓɁALтɂă`FbN
					if(data.contLines[changedLineNum].checkTerminalNear(data)!=SLData.DIR_ALL){
						smallLoopFlag=true;		//[vւ΃tO𗧂ĂĂdepth 1ŏ
					}							//idepth 4̒depth 1ĂяoĂ͂Ȃj
				}
			}else{
				data.setNewHorLineNum(x,y,before,after);	//ύX̂
			}
			//
			int result=checkResult(data);
			if(result==RES_ERROR){
				tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_HOR;
			}else if(result==RES_CHANGE){
				tmpChangeX=x;tmpChangeY=y;tmpChangeLine=ANA_DIR_HOR;
			}
			return result;
		}else if(before==after){
			return RES_SAME;
		}else{
			tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_HOR;
			return RES_ERROR;
		}
	}
	private int changeVerLine(SLData data,int x,int y,int before,int after){
		if(before==SLData.LINE_BLANK){
			data.lineVer[x][y]=after;
			if(masterMessageFlag){	puzzle.changeFlag=true;	}	//E蔻̎͌f[^̕ύX͂Ȃ
			if(analyzeLevel>=4){				//[vւ̃`FbN܂
				int changedLineNum=data.setNewVerLineNum(x,y,before,after);
				if(changedLineNum!=0){			//ύXƓɁALтɂă`FbN
					if(data.contLines[changedLineNum].checkTerminalNear(data)!=SLData.DIR_ALL){
						smallLoopFlag=true;		//[vւ΃tO𗧂ĂĂdepth 1ŏ
					}							//idepth 4̒depth 1ĂяoĂ͂Ȃj
				}
			}else{
				data.setNewVerLineNum(x,y,before,after);	//ύX̂
			}
			//
			int result=checkResult(data);
			if(result==RES_ERROR){
				tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_VER;
			}else if(result==RES_CHANGE){
				tmpChangeX=x;tmpChangeY=y;tmpChangeLine=ANA_DIR_VER;
			}
			return result;
		}else if(before==after){
			return RES_SAME;
		}else{
			tmpErrorX=x;tmpErrorY=y;tmpErrorLine=ANA_DIR_VER;
			return RES_ERROR;
		}
	}
	//-------------------------------------------------------------*** level 1- ***
	//VɕύX閈Ɍʂ𔻒肵ĕԂ
	//-------------------------------------------------------------*** depth 5 ***
	private int checkResult(SLData data){
		//}XE_G[
		if(data.errors.size()!=0){
			return RES_ERROR;
		}
		//[ṽG[AсA
		if(SLContinueLine.loopSum==1){
			if(SLContinueLine.lineSum>1){
				return RES_ERROR;
			}else{
				/*
				if(data.checkNolineNumber()){
					return RES_NOLINE_NUMBER;	//[v1.4]Pƃ[vɁu͂ꐔvi[v1.7]Œuj
				}else{
					return RES_FINISH;
				}*/
				if(data.checkLinelessNumber()){
					return RES_LINELESS_NUMBER;	//[v1.7]Pƃ[vɁus̐v
				}else{
					return RES_FINISH;
				}
			}
		}
		//s
		return RES_CHANGE;
	}
	//-------------------------------------------------------------
	//G[⊮_CAOŒʒm
	//-------------------------------------------------------------
	//
	private boolean showErrorMessage(String message){
		if(messageFlag && masterMessageFlag){
			//bZ[W\Oɍĕ`悵Ăiw@ł͕KvȂjiLevel0͂ł͕svȂ̂ccj
			puzzle.repaint();
			//
			JOptionPane.showMessageDialog(puzzle,message,LST.V[LST.ERROR],JOptionPane.ERROR_MESSAGE);
		}
		return true;
	}
	//
	private boolean showErrorMessage(){
		if(messageFlag && masterMessageFlag){
			//bZ[W\Oɍĕ`悵Ăiw@ł͕KvȂj
			puzzle.repaint();
			//
			switch(tmpErrorLine){
			case ANA_DIR_HOR:
				JOptionPane.showMessageDialog(puzzle,LST.V[LST.CONTRADICTION]+"\n"+LST.V[LST.HORIZONTAL]+" "+LST.V[LST.LINE]+"i"+LST.V[LST.RIGHT]+"F"+(tmpErrorX+1)+","+LST.V[LST.DOWN]+"F"+(tmpErrorY+1)+"j",
						LST.V[LST.ERROR],JOptionPane.ERROR_MESSAGE);
			case ANA_DIR_VER:
				JOptionPane.showMessageDialog(puzzle,LST.V[LST.CONTRADICTION]+"\n"+LST.V[LST.VERTICAL]+" "+LST.V[LST.LINE]+"i"+LST.V[LST.RIGHT]+"F"+(tmpErrorX+1)+","+LST.V[LST.DOWN]+"F"+(tmpErrorY+1)+"j",
						LST.V[LST.ERROR],JOptionPane.ERROR_MESSAGE);
			}
		}
		return true;
	}
	private boolean showFinishMessage(){
		if(messageFlag && masterMessageFlag){
			//bZ[W\Oɍĕ`悵Ăiw@ł͕KvȂj
			puzzle.repaint();
			//
			JOptionPane.showMessageDialog(puzzle,LST.V[LST.COMPLETED],LST.V[LST.ANALYZE],JOptionPane.INFORMATION_MESSAGE);
		}
		return true;
	}
}
