
import java.awt.Color;
import java.awt.Point;
import java.util.ArrayList;

public class SLContinueLine implements Cloneable{
	//Aɂ鑍Aƃ[v
	static int lineSum=0;
	static int loopSum=0;
	//
	boolean loopFlag;
	Color paintColor;
	//f[̍WiG[Ɛ肵Ȃj
	ArrayList<Point> terminalPoints;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	//ʏp
	public SLContinueLine(){
		loopFlag=false;
		paintColor=makeColor();
		//A𑝂₷iz񂩂폜ƂɌ炷j
		lineSum++;
		//f[͒ʏ2
		terminalPoints=new ArrayList<Point>(2);
	}
	public SLContinueLine(Point point1,Point point2){
		this();
		//VK̘ÁA[RXgN^ňꏏɓo^
		terminalPoints.add(point1);
		terminalPoints.add(point2);
	}
	//Ǘpiz0Ԃɓj
	public SLContinueLine(int def){
		loopFlag=false;
		paintColor=Color.BLACK;	//fobOp
		//
		terminalPoints=new ArrayList<Point>(0);
		//
		lineSum=def;
		loopSum=def;
	}
	//-------------------------------------------------------------
	//w@ŎgIuWFNg̕
	//-------------------------------------------------------------
	private SLContinueLine(SLContinueLine cont){
		loopFlag=cont.loopFlag;
		paintColor=new Color(cont.paintColor.getRGB());
		//
		terminalPoints=new ArrayList<Point>(2);
		for(int p=0;p<cont.terminalPoints.size();p++){
			terminalPoints.add(new Point(cont.terminalPoints.get(p)));
		}
		//鎞ɃNXϐ͏Ă̂ŁAŒǉ
		lineSum++;
	}
	public SLContinueLine clone(){
		return new SLContinueLine(this);
	}
	//-------------------------------------------------------------
	//[vύX͕K\bhiύXꂽ̂݃[vςj
	//-------------------------------------------------------------
	public void changeLoop(boolean f,SLData puzzleData){
		if(f){
			if(!loopFlag){
				loopFlag=f;
				loopSum++;
			}
		}else{
			if(loopFlag){
				loopFlag=f;
				loopSum--;
			}
		}
	}
	//-------------------------------------------------------------
	//f[̍WǗ
	//-------------------------------------------------------------
	//AfꂽꍇɌĂ΂
	public void deleteTerminals(ArrayList<Point> points){
		for(int p=0;p<points.size();p++){
			terminalPoints.remove(points.get(p));
		}
	}
	//x4͂ŁA2̒f[ׂ荇Ăď[vsǂ𔻒
	//߂ĺA_0_1ւ̕
	public int checkTerminalNear(SLData data){
		//
		if(terminalPoints.size()!=2){	return SLData.DIR_ALL;	}
		//
		int dx=terminalPoints.get(1).x-terminalPoints.get(0).x;
		int dy=terminalPoints.get(1).y-terminalPoints.get(0).y;
		if(dx==0){
			if(dy==1){
				if(data.lineVer[terminalPoints.get(0).x][terminalPoints.get(0).y]==SLData.LINE_BLANK && checkNotLonelyLoop(data)){
					return SLData.DIR_DOWN;
				}
			}else if(dy==-1){
				if(data.lineVer[terminalPoints.get(1).x][terminalPoints.get(1).y]==SLData.LINE_BLANK && checkNotLonelyLoop(data)){
					return SLData.DIR_UP;
				}
			}
		}else if(dx==1){
			if(dy==0){
				if(data.lineHor[terminalPoints.get(0).x][terminalPoints.get(0).y]==SLData.LINE_BLANK && checkNotLonelyLoop(data)){
					return SLData.DIR_RIGHT;
				}
			}
		}else if(dx==-1){
			if(dy==0){
				if(data.lineHor[terminalPoints.get(1).x][terminalPoints.get(1).y]==SLData.LINE_BLANK && checkNotLonelyLoop(data)){
					return SLData.DIR_LEFT;
				}
			}
		}
		//ׂ荇ĂȂ
		return SLData.DIR_ALL;
	}
	//[vւ̔őɐ肤邩`FbN
	private boolean checkNotLonelyLoop(SLData data){
		//ɐ
		if(lineSum>1){	return true;	}
		/*
		//[v1.4]Pƃ[vɁu͂ꐔvȂiԈ̂[v1.7]ŏCj
		return data.checkNolineNumber();
		*/
		//[v1.7]
		//Pƃ[v鎞Ɂus̐ṽ`FbNĂ͂Ȃ
		//ׂŌ̐܂ރ}Xus̐vł邩Ȃ
		//return data.checkLinelessNumber();	ԈႢ
		//Pɐ̐Ŕ肵Aȏ̃`FbN̓[vɍs΂
		return false;
	}
	//-------------------------------------------------------------
	//F̕`F쐬
	//-------------------------------------------------------------
	public static Color makeColor(){
		int r=16*getRandomInt(1,15);
		int g=16*getRandomInt(1,15);
		int b=16*getRandomInt(1,15);
		return new Color(r,g,b);
	}
	public static int getRandomInt(int min,int max){
		return (int)(min+Math.random()*(max-min));
	}
}
