import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class SLSizeDialog extends JDialog implements ActionListener ,ChangeListener, WindowListener {
	//Ăяo
	SLFrame frame;
	//
	JSlider sliderSize=new JSlider(8,80,26);
	SpinnerNumberModel spinnerSize=new SpinnerNumberModel(26,8,80,1);
	JButton buttonOk=new JButton();
	JButton buttonCancel=new JButton();
	//̃}XTCY
	int cellSize;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SLSizeDialog(SLFrame frm){
		super(frm,true);
		frame=frm;
		//XC_[ݒ
		sliderSize.setMajorTickSpacing(12);
		sliderSize.setMinorTickSpacing(2);
		sliderSize.setPaintLabels(true);
		sliderSize.setPaintTicks(true);
		//
		JPanel panelSize=new JPanel();
		panelSize.add(sliderSize);
		panelSize.add(new JSpinner(spinnerSize));
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelSize,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//
		sliderSize.addChangeListener(this);
		spinnerSize.addChangeListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		addWindowListener(this);
		//ŃTCY
		setLanguageText();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//-------------------------------------------------------------
	//t@CύX𔽉f
	//-------------------------------------------------------------
	public void setLanguageText(){
		setTitle(LST.V[LST.SQUARE]+" "+LST.V[LST.SIZE]);
		//
		buttonOk.setText(LST.V[LST.OK]);
		buttonCancel.setText(LST.V[LST.CANCEL]);
		//TCY
		pack();
	}
	//-------------------------------------------------------------
	//\OɍŐVf[^K
	//-------------------------------------------------------------
	public void setValue(int v){
		spinnerSize.setValue(v);
		sliderSize.setValue(v);
		//̃}XTCYi[Ă
		cellSize=v;
	}
	//-------------------------------------------------------------
	//Rg[̃Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonOk){
			setVisible(false);
			//}X̑傫͊ɕύXĂ
			//OK{^Ńt[TCY̕ύX
			frame.fitFrameSize(false);
		}else if(object==buttonCancel){
			setVisible(false);
			//LZȂ}X̃TCYɖ߂
			frame.changeSquareSize(cellSize);
		}
	}
	//XC_[ƃXsi[𓯊iɃ}X̑傫ꎞIɕύXj
	public void stateChanged(ChangeEvent e) {
		if(e.getSource()==sliderSize){
			spinnerSize.setValue(sliderSize.getValue());
		}else if(e.getSource()==spinnerSize){
			sliderSize.setValue(Integer.parseInt(spinnerSize.getValue().toString()));
		}
		//Xsi[̒l}X̑傫ꎞIɕύXił̓t[TCY͕ύXȂj
		frame.changeSquareSize(Integer.parseInt(spinnerSize.getValue().toString()));
	}
	//-------------------------------------------------------------
	//EBhECxg
	//-------------------------------------------------------------
	public void windowActivated(WindowEvent arg0) {
	}
	public void windowClosed(WindowEvent arg0) {
	}
	public void windowClosing(WindowEvent e) {
		//E~󂩂Ȃ}X̃TCYɖ߂
		frame.changeSquareSize(cellSize);
	}
	public void windowDeactivated(WindowEvent arg0) {
	}
	public void windowDeiconified(WindowEvent arg0) {
	}
	public void windowIconified(WindowEvent arg0) {
	}
	public void windowOpened(WindowEvent arg0) {
	}
}
